diff --git a/corefreq-cli.c b/corefreq-cli.c
index 4fb718f9..723e7177 100644
--- a/corefreq-cli.c
+++ b/corefreq-cli.c
@@ -2673,8 +2673,8 @@ void Top(SHM_STRUCT *Shm, char option)
 	    sliceLen = sprintf(sliceStr,   "%14ld ",
 				Shm->Sleep.sliceWaiting.tv_nsec / 1000000L),
 
-	    autoLen = sprintf(autoStr,     "[%3s]",
-				enabled((Shm->Registration.AutoClock & 0b10))),
+	    autoLen = sprintf(autoStr,     "<%3s>",
+			   enabled((Shm->Registration.AutoClock & 0b10) != 0)),
 
 	    experLen = sprintf(experStr,   "<%3s>",
 				enabled((Shm->Registration.Experimental != 0))),
@@ -2724,7 +2724,7 @@ void Top(SHM_STRUCT *Shm, char option)
 	StoreTCell(wSet, SCANKEY_NULL,   " Slice Wait(ms)                 ",
 							MAKE_PRINT_UNFOCUS);
 
-	StoreTCell(wSet, SCANKEY_NULL,   " Auto Clock                     ",
+	StoreTCell(wSet, OPS_AUTOCLOCK,  " Auto Clock                     ",
 		attribute[((Shm->Registration.AutoClock & 0b10) != 0)]);
 
 	StoreTCell(wSet,OPS_EXPERIMENTAL," Experimental                   ",
@@ -3919,6 +3919,41 @@ void Top(SHM_STRUCT *Shm, char option)
 		RING_WRITE(Shm->Ring[0], COREFREQ_IOCTL_INTERVAL, 3000);
     }
     break;
+    case OPS_AUTOCLOCK:
+    {
+	Window *win = SearchWinListById(scan->key, &winList);
+      if (win == NULL)
+	{
+	const int bON = ((Shm->Registration.AutoClock & 0b10) != 0);
+	const Coordinate origin = {
+		.col = (drawSize.width - strlen((char *) blankStr)) / 2,
+		.row = TOP_HEADER_ROW + 4
+	}, select = {
+		.col = 0,
+		.row = bON ? 2 : 1
+	};
+	AppendWindow(CreateBox(scan->key, origin, select, " Auto Clock ",
+		blankStr, blankAttr, SCANKEY_NULL,
+		stateStr[1][bON], stateAttr[bON] , OPS_AUTOCLOCK_ON,
+		stateStr[0][!bON],stateAttr[!bON], OPS_AUTOCLOCK_OFF,
+		blankStr, blankAttr, SCANKEY_NULL),
+		&winList);
+      } else
+		SetHead(&winList, win);
+    }
+    break;
+    case OPS_AUTOCLOCK_OFF:
+    {
+      if (!RING_FULL(Shm->Ring[0]))
+       RING_WRITE(Shm->Ring[0], COREFREQ_IOCTL_AUTOCLOCK, COREFREQ_TOGGLE_OFF);
+    }
+    break;
+    case OPS_AUTOCLOCK_ON:
+    {
+      if (!RING_FULL(Shm->Ring[0]))
+	RING_WRITE(Shm->Ring[0], COREFREQ_IOCTL_AUTOCLOCK, COREFREQ_TOGGLE_ON);
+    }
+    break;
     case OPS_EXPERIMENTAL:
     {
 	Window *win = SearchWinListById(scan->key, &winList);
diff --git a/corefreq-cli.h b/corefreq-cli.h
index 8197f319..7bdf8c02 100644
--- a/corefreq-cli.h
+++ b/corefreq-cli.h
@@ -22,12 +22,15 @@
 #define OPS_INTERVAL_2000	0x1000000000001071
 #define OPS_INTERVAL_2500	0x1000000000001081
 #define OPS_INTERVAL_3000	0x1000000000001091
-#define OPS_EXPERIMENTAL	0x1000000000002000
-#define OPS_EXPERIMENTAL_OFF	0x1000000000002001
-#define OPS_EXPERIMENTAL_ON	0x1000000000002002
-#define OPS_INTERRUPTS		0x1000000000004000
-#define OPS_INTERRUPTS_OFF	0x1000000000004001
-#define OPS_INTERRUPTS_ON	0x1000000000004002
+#define OPS_AUTOCLOCK		0x1000000000002000
+#define OPS_AUTOCLOCK_OFF	0x1000000000002001
+#define OPS_AUTOCLOCK_ON	0x1000000000002002
+#define OPS_EXPERIMENTAL	0x1000000000004000
+#define OPS_EXPERIMENTAL_OFF	0x1000000000004001
+#define OPS_EXPERIMENTAL_ON	0x1000000000004002
+#define OPS_INTERRUPTS		0x1000000000008000
+#define OPS_INTERRUPTS_OFF	0x1000000000008001
+#define OPS_INTERRUPTS_ON	0x1000000000008002
 
 #define BOXKEY_EIST		0x3000000000000004
 #define BOXKEY_EIST_OFF 	0x3000000000000005
diff --git a/corefreqk.c b/corefreqk.c
index 84fef443..d9c0fb3a 100644
--- a/corefreqk.c
+++ b/corefreqk.c
@@ -7028,6 +7028,20 @@ static long CoreFreqK_ioctl(	struct file *filp,
 		Controller_Start(1);
 		rc = 0;
 		break;
+	case COREFREQ_IOCTL_AUTOCLOCK:
+		Controller_Stop(1);
+		switch (arg) {
+			case COREFREQ_TOGGLE_OFF:
+				BITCLR(LOCKLESS, AutoClock, 1);
+				break;
+			case COREFREQ_TOGGLE_ON:
+				BITSET(LOCKLESS, AutoClock, 1);
+				break;
+			}
+		Proc->Registration.AutoClock = AutoClock;
+		Controller_Start(1);
+		rc = 0;
+		break;
 	case COREFREQ_IOCTL_EXPERIMENTAL:
 		switch (arg) {
 		    case COREFREQ_TOGGLE_OFF:
diff --git a/coretypes.h b/coretypes.h
index 47022468..a9b6e778 100644
--- a/coretypes.h
+++ b/coretypes.h
@@ -4,7 +4,7 @@
  * Licenses: GPL2
  */
 
-#define COREFREQ_VERSION	"1.32.1"
+#define COREFREQ_VERSION	"1.32.2"
 
 enum {	GenuineIntel,		\
 	Core_Yonah,		\
@@ -1340,27 +1340,28 @@ typedef struct {
 #define COREFREQ_IOCTL_SYSONCE		_IO(COREFREQ_IOCTL_MAGIC, 0x2)
 #define COREFREQ_IOCTL_MACHINE		_IO(COREFREQ_IOCTL_MAGIC, 0x3)
 #define COREFREQ_IOCTL_INTERVAL 	_IO(COREFREQ_IOCTL_MAGIC, 0x4)
-#define COREFREQ_IOCTL_EXPERIMENTAL	_IO(COREFREQ_IOCTL_MAGIC, 0x5)
-#define COREFREQ_IOCTL_INTERRUPTS	_IO(COREFREQ_IOCTL_MAGIC, 0x6)
-#define COREFREQ_IOCTL_EIST		_IO(COREFREQ_IOCTL_MAGIC, 0x7)
-#define COREFREQ_IOCTL_C1E		_IO(COREFREQ_IOCTL_MAGIC, 0x8)
-#define COREFREQ_IOCTL_TURBO		_IO(COREFREQ_IOCTL_MAGIC, 0x9)
-#define COREFREQ_IOCTL_C1A		_IO(COREFREQ_IOCTL_MAGIC, 0xa)
-#define COREFREQ_IOCTL_C3A		_IO(COREFREQ_IOCTL_MAGIC, 0xb)
-#define COREFREQ_IOCTL_C1U		_IO(COREFREQ_IOCTL_MAGIC, 0xc)
-#define COREFREQ_IOCTL_C3U		_IO(COREFREQ_IOCTL_MAGIC, 0xd)
-#define COREFREQ_IOCTL_CC6		_IO(COREFREQ_IOCTL_MAGIC, 0xe)
-#define COREFREQ_IOCTL_PC6		_IO(COREFREQ_IOCTL_MAGIC, 0xf)
-#define COREFREQ_IOCTL_PKGCST		_IO(COREFREQ_IOCTL_MAGIC, 0x10)
-#define COREFREQ_IOCTL_IOMWAIT		_IO(COREFREQ_IOCTL_MAGIC, 0x11)
-#define COREFREQ_IOCTL_IORCST		_IO(COREFREQ_IOCTL_MAGIC, 0x12)
-#define COREFREQ_IOCTL_ODCM		_IO(COREFREQ_IOCTL_MAGIC, 0x13)
-#define COREFREQ_IOCTL_ODCM_DC		_IO(COREFREQ_IOCTL_MAGIC, 0x14)
-#define COREFREQ_IOCTL_CPU_OFF		_IO(COREFREQ_IOCTL_MAGIC, 0x15)
-#define COREFREQ_IOCTL_CPU_ON		_IO(COREFREQ_IOCTL_MAGIC, 0x16)
-#define COREFREQ_IOCTL_TURBO_CLOCK	_IO(COREFREQ_IOCTL_MAGIC, 0x17)
-#define COREFREQ_IOCTL_UNCORE_CLOCK	_IO(COREFREQ_IOCTL_MAGIC, 0x18)
-#define COREFREQ_IOCTL_CLEAR_EVENTS	_IO(COREFREQ_IOCTL_MAGIC, 0x19)
+#define COREFREQ_IOCTL_AUTOCLOCK	_IO(COREFREQ_IOCTL_MAGIC, 0x5)
+#define COREFREQ_IOCTL_EXPERIMENTAL	_IO(COREFREQ_IOCTL_MAGIC, 0x6)
+#define COREFREQ_IOCTL_INTERRUPTS	_IO(COREFREQ_IOCTL_MAGIC, 0x7)
+#define COREFREQ_IOCTL_EIST		_IO(COREFREQ_IOCTL_MAGIC, 0x8)
+#define COREFREQ_IOCTL_C1E		_IO(COREFREQ_IOCTL_MAGIC, 0x9)
+#define COREFREQ_IOCTL_TURBO		_IO(COREFREQ_IOCTL_MAGIC, 0xa)
+#define COREFREQ_IOCTL_C1A		_IO(COREFREQ_IOCTL_MAGIC, 0xb)
+#define COREFREQ_IOCTL_C3A		_IO(COREFREQ_IOCTL_MAGIC, 0xc)
+#define COREFREQ_IOCTL_C1U		_IO(COREFREQ_IOCTL_MAGIC, 0xd)
+#define COREFREQ_IOCTL_C3U		_IO(COREFREQ_IOCTL_MAGIC, 0xe)
+#define COREFREQ_IOCTL_CC6		_IO(COREFREQ_IOCTL_MAGIC, 0xf)
+#define COREFREQ_IOCTL_PC6		_IO(COREFREQ_IOCTL_MAGIC, 0x10)
+#define COREFREQ_IOCTL_PKGCST		_IO(COREFREQ_IOCTL_MAGIC, 0x11)
+#define COREFREQ_IOCTL_IOMWAIT		_IO(COREFREQ_IOCTL_MAGIC, 0x12)
+#define COREFREQ_IOCTL_IORCST		_IO(COREFREQ_IOCTL_MAGIC, 0x13)
+#define COREFREQ_IOCTL_ODCM		_IO(COREFREQ_IOCTL_MAGIC, 0x14)
+#define COREFREQ_IOCTL_ODCM_DC		_IO(COREFREQ_IOCTL_MAGIC, 0x15)
+#define COREFREQ_IOCTL_CPU_OFF		_IO(COREFREQ_IOCTL_MAGIC, 0x16)
+#define COREFREQ_IOCTL_CPU_ON		_IO(COREFREQ_IOCTL_MAGIC, 0x17)
+#define COREFREQ_IOCTL_TURBO_CLOCK	_IO(COREFREQ_IOCTL_MAGIC, 0x18)
+#define COREFREQ_IOCTL_UNCORE_CLOCK	_IO(COREFREQ_IOCTL_MAGIC, 0x19)
+#define COREFREQ_IOCTL_CLEAR_EVENTS	_IO(COREFREQ_IOCTL_MAGIC, 0x1a)
 
 #define COREFREQ_ORDER_MAGIC 0xc6
 
